diff --git a/minizip.c b/minizip.c
index 2497d0ab..87521ec7 100644
--- a/minizip.c
+++ b/minizip.c
@@ -322,7 +322,7 @@ int32_t minizip_list(void *handle)
         mz_zip_time_t_to_tm(file_info->modified_date, &tmu_date);
 
         string_dir = "";
-        if (mz_attrib_is_dir(file_info->external_fa, file_info->version_madeby) == MZ_OK)
+        if (mz_zip_attrib_is_dir(file_info->external_fa, file_info->version_madeby) == MZ_OK)
         {
             string_dir = "/";
             string_method = "";
@@ -399,7 +399,7 @@ int32_t minizip_extract_currentfile(void *handle, const char *destination, const
     }
     
     // If zip entry is a directory then create it on disk
-    if (mz_attrib_is_dir(file_info->external_fa, file_info->version_madeby) == MZ_OK)
+    if (mz_zip_attrib_is_dir(file_info->external_fa, file_info->version_madeby) == MZ_OK)
     {
         printf("Creating directory: %s\n", out_path);
         mz_make_dir(out_path);
diff --git a/mz_os.c b/mz_os.c
index b463dd16..3f7f4a1a 100644
--- a/mz_os.c
+++ b/mz_os.c
@@ -98,29 +98,6 @@ int32_t mz_path_combine(char *path, const char *join, int32_t max_path)
     return MZ_OK;
 }
 
-int32_t mz_attrib_is_dir(int32_t attributes, int32_t version_madeby)
-{
-    int32_t host_system = 0;
-
-    if (version_madeby == 0)
-        host_system = MZ_VERSION_MADEBY_HOST_SYSTEM;
-    else
-        host_system = (uint8_t)(version_madeby >> 8);
-
-    if (host_system == MZ_HOST_SYSTEM_MSDOS || host_system == MZ_HOST_SYSTEM_WINDOWS_NTFS)
-    {
-        if ((attributes & 0x10) == 0x10) // FILE_ATTRIBUTE_DIRECTORY
-            return MZ_OK;
-    }
-    else if (host_system == MZ_HOST_SYSTEM_UNIX || host_system == MZ_HOST_SYSTEM_OSX_DARWIN)
-    {
-        if ((attributes & 00170000) == 0040000) // S_ISDIR
-            return MZ_OK;
-    }
-
-    return MZ_EXIST_ERROR;
-}
-
 int32_t mz_get_file_crc(const char *path, uint32_t *result_crc)
 {
     void *stream = NULL;
diff --git a/mz_os.h b/mz_os.h
index 148bca60..903cc676 100644
--- a/mz_os.h
+++ b/mz_os.h
@@ -53,9 +53,6 @@ int32_t mz_make_dir(const char *path);
 int32_t mz_path_combine(char *path, const char *join, int32_t max_path);
 // Combines two paths
 
-int32_t mz_attrib_is_dir(int32_t attributes, int32_t version_madeby);
-// Checks to see if the attribute is a directory
-
 int32_t mz_get_file_crc(const char *path, uint32_t *result_crc);
 // Gets the crc32 hash of a file
 
diff --git a/mz_zip.c b/mz_zip.c
index a1f27060..1bbd728d 100644
--- a/mz_zip.c
+++ b/mz_zip.c
@@ -1297,7 +1297,7 @@ extern int32_t mz_zip_entry_write_open(void *handle, const mz_zip_file *file_inf
         zip->file_info.aes_encryption_mode = MZ_AES_ENCRYPTION_MODE_256;
 #endif
 
-    if (compress_level == 0)
+    if ((compress_level == 0) || (mz_zip_attrib_is_dir(file_info->external_fa, file_info->version_madeby) == MZ_OK))
         compression_method = MZ_COMPRESS_METHOD_RAW;
 
     if (err == MZ_OK)
@@ -1555,6 +1555,26 @@ extern int32_t mz_zip_locate_entry(void *handle, const char *filename, mz_filena
 
 /***************************************************************************/
 
+int32_t mz_zip_attrib_is_dir(int32_t attributes, int32_t version_madeby)
+{
+    int32_t host_system = (uint8_t)(version_madeby >> 8);
+
+    if (host_system == MZ_HOST_SYSTEM_MSDOS || host_system == MZ_HOST_SYSTEM_WINDOWS_NTFS)
+    {
+        if ((attributes & 0x10) == 0x10) // FILE_ATTRIBUTE_DIRECTORY
+            return MZ_OK;
+    }
+    else if (host_system == MZ_HOST_SYSTEM_UNIX || host_system == MZ_HOST_SYSTEM_OSX_DARWIN)
+    {
+        if ((attributes & 00170000) == 0040000) // S_ISDIR
+            return MZ_OK;
+    }
+
+    return MZ_EXIST_ERROR;
+}
+
+/***************************************************************************/
+
 static int32_t mz_zip_invalid_date(const struct tm *ptm)
 {
 #define datevalue_in_range(min, max, value) ((min) <= (value) && (value) <= (max))
diff --git a/mz_zip.h b/mz_zip.h
index 4f13e487..2b6d0eff 100644
--- a/mz_zip.h
+++ b/mz_zip.h
@@ -130,6 +130,9 @@ extern int32_t mz_zip_locate_entry(void *handle, const char *filename,
 
 /***************************************************************************/
 
+int32_t  mz_zip_attrib_is_dir(int32_t attributes, int32_t version_madeby);
+// Checks to see if the attribute is a directory based on platform
+
 int32_t  mz_zip_dosdate_to_tm(uint64_t dos_date, struct tm *ptm);
 // Convert dos date/time format to struct tm
 
